﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI.WebControls;
using System.Web.UI;

namespace PopupCellTypeDemo_Modal
{
    [Serializable()]
    public class PopupCellType : FarPoint.Web.Spread.GeneralCellType
    {
        public PopupCellType()
        {

        }

        private string _id;
        private string _onClickPopup;
        private string _onEnterPopup;

        public string ID
        {
            get { return _id; }
            set { _id = value; }
        }

        public string OnClickPopup
        {
            get { return _onClickPopup; }
            set { _onClickPopup = value; }
        }

        public string OnEnterPopup
        {
            get { return _onEnterPopup; }
            set { _onEnterPopup = value; }
        }

        public override System.Web.UI.Control GetEditorControl(string id, System.Web.UI.WebControls.TableCell parent, FarPoint.Web.Spread.Appearance style, FarPoint.Web.Spread.Inset margin, object value, bool upperLevel)
        {
            Table table = new Table();
            table.CellPadding = 0;
            table.CellSpacing = 0;
            table.BorderStyle = BorderStyle.None;
            table.BorderWidth = new Unit(0, UnitType.Pixel);
            table.Width = new Unit(100, UnitType.Percentage);

            TableRow row = new TableRow();

            TableCell cell = new TableCell();
            cell.VerticalAlign = VerticalAlign.Middle;
            cell.HorizontalAlign = HorizontalAlign.Left;

            // 用户可以直接在 TextBox 中输入数据
            TextBox tb = new TextBox();
            tb.Width = new Unit(99, UnitType.Percentage);
            tb.ID = "PopupEditor" + _id;
            // 如果不希望用户直接输入数据，可以将TextBox设置为ReadOnly，这样就可以保证数据的有效性
            //tb.ReadOnly = true;
            if (!string.IsNullOrEmpty(_onEnterPopup))
            {
                tb.Attributes.Add("onkeydown", _onEnterPopup);
            }
            cell.Controls.Add(tb);
            row.Cells.Add(cell);

            cell = new TableCell();
            cell.Width = new Unit(22, UnitType.Pixel);
            cell.VerticalAlign = VerticalAlign.Middle;
            cell.HorizontalAlign = HorizontalAlign.Right;

            // 如果用户不想通过输入的方式填写数据，可以点击[检索]按钮，在弹出的窗体中选择需要的数据
            ImageButton img = new ImageButton();
            img.ImageUrl = @"Images/Search.jpg";
            img.BorderColor = System.Drawing.Color.LightGray;
            img.BorderStyle = BorderStyle.Solid;
            img.BorderWidth = new Unit(1, UnitType.Pixel);
            if (!string.IsNullOrEmpty(_onClickPopup))
            {
                img.Attributes.Add("onclick", _onClickPopup);
            }            
            cell.Controls.Add(img);
            row.Cells.Add(cell);

            table.Rows.Add(row);

            return table;
        }

        public override string EditorClientScriptUrl
        {
            get
            {
                return "PopupEditorScript.htc";
            }
        }
    }
}